"""
Selection Protocols
--------------------------------------------------------------------------------
These protocols will determine which individuals will participate in the
selection, based upon the type (parent/child).

Containing all the three basic protocols for adult selection:
- Full Generational Replacement
- Over-production
- Generational Mixing
"""
from operator import attrgetter

#Full Generational Replacement:
#All previous adults die -> all children gets spot in adult pool
# TYPE 1
def generationalReplacement(children):
        adults = []
        adults = children
        return adults

#Over-production: All previous adults die, but number of spots in adult pool (m)
#is smaller than number of children (n) m < n
# TYPE 2
def overProduction(inchildren, amount):
    newadults = []
    #sorts children list based on fitness
    children = sorted(inchildren, key=attrgetter('fitness'), reverse=False)

    if len(children)>amount:
        newadults = []
        for i in range(0, amount):
            newadults.append(children[i])
    else:
        return children
    return newadults


#Generational Mixing: Both previous adults and children compete for spot in next
# generation
# TYPE 2
def generationalMixing(inchildren, adults, amount):
    newadults = []
    if len(adults) == 0:
        children = sorted(inchildren, key=attrgetter('fitness'), reverse=False)
        for i in range(0, amount):
            newadults.append(children[i])
        return newadults
    else:
        adults.extend(inchildren)
        #sort input list, based on fitness
        children = sorted(adults, key=attrgetter('fitness'), reverse=False)
        for i in range(0, amount):
            newadults.append(children[i])
        return newadults

